﻿// Copyright (C) 2009 Choonghwan Lee (linjus.lee@gmail.com)
//
// This file is part of amanda.
//
// amanda is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// amanda is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with amanda. If not, see <http://www.gnu.org/licenses/>.

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;

namespace manager
{
	public class LogMessage
	{
		public enum Kind
		{
			SUCCESS,
			FAIL,
			INFO,
		}

		private Kind kind;
		public string IconPath
		{
			get
			{
				switch (this.kind) {
					case Kind.SUCCESS:
						return @"Resources\log_success.png";
					case Kind.FAIL:
						return @"Resources\log_fail.png";
					case Kind.INFO:
						return @"Resources\log_info.png";
				}
				return null;
			}
		}

		public string Message
		{ get; private set; }

		public LogMessage(Kind kind, string msg)
		{
			this.kind = kind;
			this.Message = msg;
		}
	}

	public class LogMessages : ObservableCollection<LogMessage>
	{
	}
}
